org.apache.poi.ss.formula

## Interface IStabilityClassifier

-     public interface IStabilityClassifier

  Used to help optimise cell evaluation result caching by allowing applications to specify which parts of a workbook are final.
  The term final is introduced here to denote immutability or 'having constant definition'. This classification refers to potential actions (on the evaluated workbook) by the evaluating application. It does not refer to operations performed by the evaluator (`WorkbookEvaluator`).
  General guidelines:
  - a plain value cell can be marked as 'final' if it will not be changed after the first call to `WorkbookEvaluator.evaluate(EvaluationCell)`.
  - a formula cell can be marked as 'final' if its formula will not be changed after the first call to `WorkbookEvaluator.evaluate(EvaluationCell)`. This remains true even if changes in dependent values may cause the evaluated value to change.
  - plain value cells should be marked as 'not final' if their plain value value may change.
  - formula cells should be marked as 'not final' if their formula definition may change.
  - cells which may switch between plain value and formula should also be marked as 'not final'.
  Notes:
  - If none of the spreadsheet cells is expected to have its definition changed after evaluation begins, every cell can be marked as 'final'. This is the most efficient / least resource intensive option.
  - To retain freedom to change any cell definition at any time, an application may classify all cells as 'not final'. This freedom comes at the expense of greater memory consumption.
  - For the purpose of these classifications, setting the cached formula result of a cell (for example in `FormulaEvaluator.evaluateFormulaCell(org.apache.poi.ss.usermodel.Cell)`) does not constitute changing the definition of the cell.
  - Updating cells which have been classified as 'final' will cause the evaluator to behave unpredictably (typically ignoring the update).
  Author:
    Josh Micich

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static IStabilityClassifier` | `TOTALLY_IMMUTABLE` Convenience implementation for situations where all cell definitions remain fixed after evaluation begins.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isCellFinal(int sheetIndex, int rowIndex, int columnIndex)` Checks if a cell's value(/formula) is fixed - in other words - not expected to be modified between calls to the evaluator.

- - ### Field Detail

    - #### TOTALLY_IMMUTABLE

          static final IStabilityClassifier TOTALLY_IMMUTABLE

      Convenience implementation for situations where all cell definitions remain fixed after evaluation begins.

  - ### Method Detail

    - #### isCellFinal

          boolean isCellFinal(int sheetIndex,
                              int rowIndex,
                              int columnIndex)

      Checks if a cell's value(/formula) is fixed - in other words - not expected to be modified between calls to the evaluator. (Note - this is an independent concept from whether a formula cell's evaluated value may change during successive calls to the evaluator).
      Parameters:
        `sheetIndex` - zero based index into workbook sheet list
        `rowIndex` - zero based row index of cell
        `columnIndex` - zero based column index of cell
      Returns:
        `false` if the evaluating application may need to modify the specified cell between calls to the evaluator.

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.